"""
Battle the robot hand to hand
slow robots
minimal jump - no jump jets
duck
punch
the enemy robot does shoot you, dodge by jumping or ducking
if you can beat him to half health, he fires missiles at you
    which destroys your robot

You get out of the wreckage and hop in a car
You are racing away from the giant robot, whos feet keep
    coming down
Heading for the emp that has been set up
You get to a bridge over a deep mine, which he blows up sending 
    the car tumbling down
He crosses through the emp field (You have to activate it
    at the right time), you also get a chance to grab a better
    gun from the rack.
Without controls, he tumbles over the cliff into the shaft
Unfortunately, the disturbance causes you to slip over the egde
    as well as the ground gives way
    
You are both falling down the shaft, and he manages to power
    up his backup generators
You land in a hanging mine cart that starts sliding away

His robot is pretty busted, but he still manages to crawl after you
He chases you through the mine shaft with you firing away
The mine opens into the woods

You take the mining bombs you got from the cart and decide
to finish this sucker once and for all

Have to climb up his legs and get the bomb planted in his face,
    and detonate it
    
Finally, the robot explodes and the enemy comes out.  You still
have to face him one on one.  He can jump into the arms of 
his former bot and shoot their lasers at you.
At some point you manage to cut his hand off.  If you can 
pick up his hand, you can also control the robot arms.

This triggers the final cut scene where you laser him to death
"""

import pyglet,random,math
pyglet.resource.path = ["data"]
pyglet.resource.reindex()
from pyglet.window import key

snd_mg = pyglet.media.load("data/mg.wav",streaming=False)
snd_explo = pyglet.media.load("data/explo.wav",streaming=False)
snd_woosh = pyglet.media.load("data/woosh.wav",streaming=False)
snd_mus = pyglet.media.load("data/rc_2_evil_dead.wav")
snd_chink = pyglet.media.load("data/chink.wav",streaming=False)

def qsprite(path,anchor=(0,0)):
    """Quickly load an image and make a sprite for it"""
    img = pyglet.resource.image(path)
    img.anchor_x,img.anchor_y = anchor
    return pyglet.sprite.Sprite(img)

logo = qsprite("logo.png")

tt = pyglet.text.HTMLLabel('<b>Showdown</b>')
tt.color = (255,255,255,0)
tt.alpha = 0
tt.alpha_delay = 100
tt.y = 50

he = pyglet.text.HTMLLabel('<b>Hit Enter to Begin</b>')
he.color = (255,255,255,0)
he.alpha = 0
he.alpha_delay = 200
he.x,he.y = [100,50]
texts = [tt,he]

class State:
    def __init__(self,win):
        self.win = win
        self.setup()
    def setup(self):
        pass
    def on_draw(self):
        self.win.clear()
        pyglet.gl.glScalef(2,2,2)
        self.realdraw()
        pyglet.gl.glScalef(0.5,0.5,0.5)
    def realdraw(self):
        logo.draw()
        [x.draw() for x in texts]
    def update(self,dt,x):
        for title in texts:
            title.alpha_delay-=1
            if title.alpha_delay<=0:
                title.alpha_delay = 0
                title.alpha+=10
                if title.alpha>255: 
                    title.alpha=255
                title.color = (255,255,255,title.alpha)
    def on_key_press(self,symbol,mods):
        if symbol==pyglet.window.key.RETURN:
            self.win.state = Game(self.win)
    def on_key_release(self,symbol,mods):
        pass
    def on_mouse_press(self,x,y,button,mods):
        pass
    def on_mouse_release(self,x,y,button,mods):
        pass
    def on_mouse_drag(self,*args):
        pass

"""    s = math.sin(-x.par.rotation*(math.pi/180.0))
    c = math.cos(-x.par.rotation*(math.pi/180.0))
    newxoff = x.off[0]*c-x.off[1]*s
    newyoff = x.off[0]*s+x.off[1]*c
    return newxoff,newyoff"""
    
def rotate(p1,p2,angle):
    """Rotate p1 about p2, return rotated p1"""
    s = math.sin(angle*(math.pi/180.0))
    c = math.cos(angle*(math.pi/180.0))
    x = p1[0]-p2[0]
    y = p1[1]-p2[1]
    xx = x*c-y*s
    yy = x*s+y*c
    xx+=p2[0]
    yy+=p2[1]
    return xx,yy
            
def col(point,part):
    radius = (part.width+part.height)/2
    center = [part.x,part.y]#list(rotate([(part.x-part.off[0])+part.width//2,(part.y+part.off[1])-part.height//2],[part.x,part.y],-part.rotation))
    if math.sqrt((point[0]-center[0])**2+(point[1]-center[1])**2)<radius:
        return True
    return False
    
class bone(pyglet.sprite.Sprite):
    def __init__(self,name,path,anchor=None,off=None,parent=None,rotation=0):
        self.name = name
        self.path = path
        img = pyglet.resource.image(path)
        if not anchor: anchor = [0,0]
        img.anchor_x,img.anchor_y = anchor
        pyglet.sprite.Sprite.__init__(self,img)
        self.original_image = self.image  #save image as an old image
        if not off: off = [0,0]
        self.off = off
        self.par = parent
        self.rot = rotation
        self.rotation = rotation
        self.children = []

class di(dict):
    def snapshot(self):
        snap = {}
        for part_name in self:
            snap[part_name]=self[part_name].rotation
        return snap
    def load_snapshot(self,snapshot):
        for k in snapshot:
            self[k].rot = snapshot[k]
    def interp(self,snapshot_start,snapshot_end,percent):
        """Returns 1 if interpolation is done"""
        steady = 1
        for k in snapshot_end:
            r1 = snapshot_end[k]
            r2 = snapshot_start[k]
            if r2==r1:
                continue
            steady = 0
            d=0
            w = 0
            w2 = 0
            if r2>r1:
                w = 1
                d = r2-r1
                if r2-r1>180:
                    d = -(360-(r2-r1))
            elif r2<r1:
                w = 2
                d = -(r1-r2)
                if r1-r2>180:
                    d = (360-(r1-r2))
            r2-=d*percent
            if r2>r1:
                w2 = 1
            elif r2<r1:
                w2 = 2
            if w!=w2:
                r2 = r1
            self[k].rot = r2
        return steady

def loadskeleton(filename,pos):
    if not pos: pos = [0,0]
    skel = di()
    skel.filename = filename
    skel.flipped = 0
    skel.snapshots = []
    f = open(filename)
    update_priority = 0
    for line in f:
        if line.startswith("!"):
            skel.snapshots.append(eval(line[1:].strip()))
            continue
        name,rest = line.split(":")
        ar = rest.strip().split(" ")
        args = [name,ar[0],eval(ar[1]),eval(ar[2]),ar[3],int(ar[4])]
        if args[4]=="None":
            args[4] = None
        else:
            args[4] = skel[args[4]]
        b = bone(*args)
        if b.par:
            b.par.children.append(b)
        skel[name]=b
        b.update_priority = update_priority
        update_priority+=1
        b.draw_priority = int(ar[5])
    f.close()
    skel["root"].x,skel["root"].y = pos
    def _cmp(ska,skb):
        return cmp(ska.update_priority,skb.update_priority)
    def srt():
        v = skel.values()
        v.sort(_cmp)
        return v
    skel.updates = srt
    def _cmp2(ska,skb):
        return cmp(ska.draw_priority,skb.draw_priority)
    def drw():
        v = skel.values()
        v.sort(_cmp2)
        for x in v:
            x.draw()
    skel.draw = drw
    if not skel.snapshots:
        skel.snapshots.append(skel.snapshot())
    def flip():
        self = skel
        self.flipped = 1-self.flipped
        for x in self.updates():
            ax = x.image.anchor_x
            ay = x.image.anchor_y
            x.image = x.original_image.get_transform(flip_x=self.flipped)
            x.image.anchor_x = x.width-ax
            x.image.anchor_y = ay
            x.off = (-x.off[0],x.off[1])
    skel.flip = flip
    return skel
            
class robot:
    def __init__(self,x,y,filename="data/r1_frame.txt"):
        self.health = 100
        self.x = x
        self.y = y
        self.dir = dir
        
        self.skel = loadskeleton(filename,[x,y])
        
        self.width = 60
        
        self.snap_i = 0
        self.anim = None
        self.anim_i = 0
        self.anim_snap = self.skel.snapshot()
        self.anim_percent = 0
        
        self.upforce = 0
        self.vel = [0.0,0.0]
        if "r1" in filename:
            self.anims = {"walk":self.skel.snapshots[0:4],"hit":self.skel.snapshots[4:9],
            "duck":self.skel.snapshots[9:11]}
    def jump(self):
        if self.bottom()<=30:
            self.upforce = 12
    def draw(self):
        self.skel.draw()
    def bottom(self):
        lowesty = 5000
        found = False
        for x in "foot1","foot2","footbase":
            if x in self.skel.keys():
                found = True
                y = self.skel[x].y
                if y<lowesty:
                    lowesty = y
        if found:
            return lowesty
        return self.y
    def update_anim(self):
        if self.anim:
            self.anim_percent+=0.2
            if self.skel.interp(self.anim_snap,self.skel.snapshots[self.anim_i],self.anim_percent) or self.anim_percent>=1.0:
                self.anim_percent = 0
                self.anim_snap = self.skel.snapshot()
                self.anim_i += 1
                if self.anim_i>=len(self.skel.snapshots):
                    self.anim_i = 0
                    return 1
    def update(self):
        if self.upforce:
            self.vel[1]+=self.upforce
            self.upforce = self.upforce*.5
            if self.upforce<1:
                self.upforce = 0
        self.skel["root"].y+=self.vel[1]
        self.vel[1]-=1
        if self.bottom()<30:
            self.skel["root"].y+=30-self.bottom()-1
            self.vel[1]=0
        dx = 0
        if key.A in self.hold:
            #~ if not self.flipped:
                #~ self.flip()
            dx -=5
        if key.D in self.hold:
            #~ if self.flipped:
                #~ self.flip()
            dx += 5
        if key.S in self.hold:
            dx = 0
        self.skel["root"].x+=dx
        root = self.skel["root"]
        if dx>0:
            if root.x+self.width>self.other.x and root.x<self.other.x+self.other.width:
                root.x = self.other.x-self.width
        if dx<0:
            if root.x<self.other.x+self.other.width and root.x+self.width>self.other.x:
                root.x = self.other.x+self.other.width
        #~ for a in [self.arm1,self.arm2]:
            #~ if dx and a.rot>45:
                #~ a.rot += a.dir
                #~ if a.rot>120:
                    #~ a.dir=-1
                #~ if a.rot<60:
                    #~ a.dir=1
            #~ else:
                #~ a.rot += (90-a.rot)/10.0
                
        self.x = self.skel["root"].x
        self.y = self.skel["root"].y
        
        for x in self.skel.updates():
            if self.skel.flipped:
                x.rotation = 360-x.rot
            else:
                x.rotation = x.rot
            while x.rotation>360: x.rotation-=360
            while x.rotation<0: x.rotation+=360
            if not getattr(x,"par",None): continue
            newxoff,newyoff = rotate([x.off[0],x.off[1]],[0,0],-x.par.rotation)
            x.x = x.par.x+newxoff
            x.y = x.par.y+newyoff
            
class Editor(State):
    def setup(self):
        self.r = robot(50,70)
        self.r.hold = []
        self.rotating = self.r.skel.updates()[0]
        x = 250
        y = 220
        self.buttons = []
        for part in self.r.skel.updates():
            b = pyglet.text.Label(part.name)
            b.bpname = part.name
            b.x = x
            b.y = y
            y-=18
            self.buttons.append(b)
        self.edit = False
    def realdraw(self):
        pyglet.gl.glBegin(pyglet.gl.GL_QUADS)
        pyglet.gl.glColor3f(0,0,0)
        pyglet.gl.glVertex3f(0,0,0)
        pyglet.gl.glColor3f(1,0,0)
        pyglet.gl.glVertex3f(320,0,0)
        pyglet.gl.glColor3f(1,0,0)
        pyglet.gl.glVertex3f(320,240,0)
        pyglet.gl.glColor3f(0,0,0)
        pyglet.gl.glVertex3f(0,240,0)
        pyglet.gl.glEnd()
        self.r.draw()
        [b.draw() for b in self.buttons]
    def update(self,*args):
        self.r.update()
        self.r.update_anim()
    def on_key_press(self,symbol,*args):
        if symbol==key.SPACE:
            self.r.anim = not self.r.anim
            print "animating:",self.r.anim
            if self.r.anim:
                self.r.anim_snap = self.r.skel.snapshot()
                self.r.anim_percent=0
        if symbol==key.E:
            self.edit = not self.edit
            if self.edit:
                self.r.skel.load_snapshot(self.r.skel.snapshots[0])
        if symbol==key.S:
            print "save..."
            self.r.skel.snapshots[self.r.snap_i]=self.r.skel.snapshot()
        if symbol==key.N:
            print "new..."
            self.r.skel.snapshots.append(self.r.skel.snapshot())
            self.r.snap_i+=1
        if symbol==key.LEFT:
            self.r.snap_i-=1
            if self.r.snap_i<0:
                self.r.snap_i=0
            self.r.skel.load_snapshot(self.r.skel.snapshots[self.r.snap_i])
            print self.r.snap_i
        if symbol==key.RIGHT:
            self.r.snap_i+=1
            while self.r.snap_i>=len(self.r.skel.snapshots):
                self.r.snap_i -= 1
            self.r.skel.load_snapshot(self.r.skel.snapshots[self.r.snap_i])
            print self.r.snap_i
        if symbol==key.F5:
            f = open(self.r.skel.filename,"w")
            for p in self.r.skel.updates():
                rot = self.r.skel.snapshots[0][p.name]
                f.write(p.name+": "+p.path+" "+str((p.image.anchor_x,p.image.anchor_y)).replace(" ","")+" "+str(p.off).replace(" ","")+" "+getattr(p.par,"name","None")+" "+str(rot)+" "+str(p.draw_priority)+"\n")
            for snap in self.r.skel.snapshots:
                f.write("!"+repr(snap)+"\n")
            f.close()
    def on_mouse_press(self,x,y,*args):
        x=x//2
        y=y//2
        now = None
        for b in self.buttons:
            if x>=b.x and x<=b.x+b.content_width and y>=b.y and y<=b.y+b.content_height:
                now = self.r.skel[b.bpname]
        if now:
            self.rotating = now
    def on_mouse_drag(self,x,y,dx,dy,*args):
        if self.rotating:
            if self.edit:
                self.rotating.off = (self.rotating.off[0]+dx,self.rotating.off[1]+dy)
            else:
                self.rotating.rot -= dx

def ai(boss,player):
    """Behaviors:
    charge, stand still, run
    """
    if not hasattr(boss,"now"):
        boss.timer = 10
        boss.now = "run"
        boss.bullets = []
        boss.missiles = []
        boss.lastshoot = 0
        boss.height = 40
        boss.shotmissiles = 0
        boss.lastmissiles = 0
    if boss.now=="stand":
        boss.hold = []
        if boss.lastshoot>0:
            boss.lastshoot-=1
        if len(boss.bullets)<5:
            c = [30,150]
            if key.S in player.hold:
                c.append(30)
            elif player.vel[1]:
                c.append(150)
            boss.height = random.choice(c)
            if boss.lastshoot==0:
                bullet = qsprite("bullet.png",(20,20))
                boss.bullets.append(bullet)
                bullet.x = boss.x-20
                bullet.y = boss.height
                snd_mg.play()
                boss.lastshoot = 20
        boss.timer -= 1
        if boss.timer<0:
            boss.timer = 50
            if abs(boss.x-player.x)>200:
                boss.now=random.choice(["charge","charge","charge","run"])
            elif abs(boss.x-player.x)<50:
                boss.now = "run"
            else:
                boss.now = random.choice(["charge","run"])
            if boss.health<50:
                if boss.lastmissiles<=0 or random.randint(0,2)==0:
                    boss.now = "missile"
                    boss.timer = 200
                    boss.lastshoot = 0
                    boss.lastmissiles = 2
            if boss.now!="missile":
                boss.lastmissiles -=1
    if boss.now=="missile":
        boss.timer -= 1
        if boss.lastshoot==0:
            m = qsprite("missile.png")
            m.x = boss.x
            m.y = 180
            m.dir = 1
            boss.missiles.append(m)
            boss.lastshoot = 16
            boss.shotmissiles += 1
        else:
            boss.lastshoot-=1
        if boss.shotmissiles>15:
            boss.shotmissiles = 0
            boss.now = "charge"
    elif boss.now=="charge":
        boss.hold=[key.A]
        boss.timer -= 1
        if boss.timer<0:
            boss.timer = 10
            if abs(boss.x-player.x)>50:
                boss.now = "stand"
                boss.timer = 50
            else:
                boss.now = "run"
    elif boss.now=="run":
        boss.hold=[key.D]
        boss.timer -= 1
        if boss.timer<0:
            boss.timer = 10
            boss.now="stand"
    if boss.hold==[key.A]:
        x = boss.x
        boss.update()
        if boss.x<x:
            boss.anim = True
            boss.update_anim()
    elif boss.hold==[key.D]:
        x = boss.x
        boss.update()
        if boss.x>x:
            boss.anim = True
            boss.update_anim()
    else:
        boss.update()
    

class Game(State):
    def setup(self):
        self.can_hold = [key.A,key.D,key.S]
        self.hold = []
        self.r1 = robot(50,70,"data/r1_frame.txt")
        self.r1.hold = self.hold
        self.r2 = robot(200,70,"data/rboss.txt")
        self.r2.hold = []
        self.r1.other = self.r2
        self.r2.other = self.r1
        self.ground = qsprite("ground.png")
        self.bg = qsprite("bg1.png")
        self.island = qsprite("island.png")
        self.cam = [0,0]
        self.fps = pyglet.clock.ClockDisplay()
        try:
            snd_mus.play()
        except:
            pass
    def realdraw(self):
        zoom = .8
        pyglet.gl.glPushMatrix()
        pyglet.gl.glScalef(zoom,zoom,zoom)
        self.bg.scale = 1.0/zoom
        self.bg.draw()
        pyglet.gl.glTranslatef(-self.cam[0]/2,-self.cam[1],0)
        amt = 450
        c = self.cam[0]/2
        self.island.x = (c//amt)*amt
        self.island.draw()
        self.island.x = (c//amt+1)*amt
        self.island.draw()
        self.island.x = (c//amt+2)*amt
        self.island.draw()
        pyglet.gl.glTranslatef(self.cam[0]/2,self.cam[1],0)
        pyglet.gl.glTranslatef(-self.cam[0],-self.cam[1],0)
        self.ground.x = (self.cam[0]//320)*320
        self.ground.draw()
        self.ground.x = (self.cam[0]//320+1)*320
        self.ground.draw()
        self.ground.x = (self.cam[0]//320+2)*320
        self.ground.draw()
        self.r1.draw()
        self.r2.draw()
        for bullet in getattr(self.r2,"bullets",[]):
            bullet.draw()
        for missile in getattr(self.r2,"missiles",[]):
            missile.draw()
        pyglet.gl.glTranslatef(self.cam[0],self.cam[1],0)
        pyglet.gl.glPopMatrix()
        self.draw_hb(self.r1.health,0,230)
        self.draw_hb(self.r2.health,320-100,230)
        if self.r1.health<=0:
            pyglet.text.Label("YOU LOSE! Press [P] to try again.",color=(0,0,0,255)).draw()
        elif self.r2.health<=0:
            pyglet.text.Label("YOU WIN! Press [P] to try again.",color=(0,0,0,255)).draw()
        self.fps.draw()
    def draw_hb(self,p,x,y,w=100,h=10):
        pyglet.gl.glBegin(pyglet.gl.GL_QUADS)
        pyglet.gl.glColor3f(0,0,0)
        pyglet.gl.glVertex2f(x,y)
        pyglet.gl.glVertex2f(x+w,y)
        pyglet.gl.glVertex2f(x+w,y+h)
        pyglet.gl.glVertex2f(x,y+h)
        pyglet.gl.glEnd()
        if p>0:
            pyglet.gl.glBegin(pyglet.gl.GL_QUADS)
            pyglet.gl.glColor3f(1,0,0)
            pyglet.gl.glVertex2f(x+1,y+1)
            pyglet.gl.glVertex2f(x+p-1,y+1)
            pyglet.gl.glVertex2f(x+p-1,y+h-1)
            pyglet.gl.glVertex2f(x+1,y+h-1)
            pyglet.gl.glEnd()
    def update(self,*args):
        def nd(*args):
            pass
        if self.r2.health<=0:
            self.r2.draw = nd
            return
        if self.r1.health<=0:
            self.r1.draw = nd
            return
        self.r1.update()
        ai(self.r2,self.r1)
        d = (self.cam[0]-(self.r1.x-110))/25.0
        self.cam[0]-=d
        hand = list(rotate(self.r1.skel["arm11"].off,[0,0],-self.r1.skel["arm11"].rotation))
        hand[0]+=self.r1.skel["arm11"].x
        hand[1]+=self.r1.skel["arm11"].y
        if self.r1.skel["arm1"].rot<10:
            for x in ["root","base","head"]:
                x = self.r2.skel[x]
                if col(hand,x):
                    self.r2.skel["root"].x=hand[0]+100
                    self.r2.x = self.r2.skel["root"].x
                    self.r2.health-=4
                    snd_chink.play()
        newb = []
        for bullet in getattr(self.r2,"bullets",[]):
            keep = True
            for partn in ["footbase","body","root"]:
                part = self.r1.skel[partn]
                if col([bullet.x,bullet.y],part):
                    self.r1.health-=7
                    keep = False
                    snd_woosh.play()
            if not keep: continue
            if bullet.x+320<self.r1.x:
                    pass
            else:
                newb.append(bullet)
            bullet.x-=10
        newm = []
        for missile in getattr(self.r2,"missiles",[]):
            keep = True
            if missile.dir == 1:
                missile.y+=5
                if missile.y>340:
                    missile.x = self.r1.x+random.choice([-100,-50,0,50,100,150,200])
                    missile.dir = -1
            elif missile.dir == -1:
                missile.y -= 8
                for partn in ["footbase","body","root"]:
                    part = self.r1.skel[partn]
                    if col([missile.x,missile.y],part):
                        self.r1.health-=15
                        keep = False
                        snd_explo.play()
                        snd_woosh.play()
            if missile.y<30:
                keep = False
                snd_explo.play()
            if keep:
                newm.append(missile)
        self.r2.missiles = newm
        self.r2.bullets = newb
        finished = self.r1.update_anim()
        if self.r1.skel.snapshots==self.r1.anims["hit"]:
            self.r1.anim = True
            if finished:
                self.r1.anim_i = 0
                self.r1.skel.snapshots = self.r1.anims["walk"]
                self.r1.anim = False
        elif (key.S in self.hold):
            if not self.r1.anim:
                self.r1.skel.snapshots = self.r1.anims["duck"]
                self.r1.anim = True
                self.r1.anim_i = 0
            if finished:
                self.r1.anim_i = 1
        elif (key.A in self.hold or key.D in self.hold):
            if not self.r1.anim or not self.r1.skel.snapshots == self.r1.anims["walk"]:
                self.r1.anim_i=0
                self.r1.skel.snapshots = self.r1.anims["walk"]
                self.r1.anim = True
        elif self.r1.skel.snapshots == list(reversed(self.r1.anims["duck"])):
            if finished:
                self.r1.anim = False
        else:
            if self.r1.skel.snapshots == self.r1.anims["duck"]:
                self.r1.anim_i = 0
                self.r1.skel.snapshots = list(reversed(self.r1.anims["duck"]))
                self.r1.anim = True
            elif self.r1.skel.snapshots == list(reversed(self.r1.anims["duck"])): 
                pass
            else:
                self.r1.anim = False
    def on_key_press(self,symbol,mods):
        if symbol in self.can_hold and not symbol in self.hold:
            self.hold.append(symbol)
        if symbol==key.SPACE and not self.r1.skel.snapshots == self.r1.anims["hit"]:
            self.r1.anim_i = 0
            self.r1.skel.snapshots = self.r1.anims["hit"]
        if symbol==key.W:
            self.r1.jump()
        if symbol==key.S:
            self.r1.anim_i=0
            self.r1.skel.snapshots = self.r1.anims["duck"]
    def on_key_release(self,symbol,mods):
        if symbol in self.can_hold and symbol in self.hold:
            self.hold.remove(symbol)

class GameWindow(pyglet.window.Window):
    def __init__(self,*args,**kwargs):
        pyglet.window.Window.__init__(self,*args,**kwargs)
        self.state = Game(self)
        pyglet.clock.schedule_interval(self.update, 1/60.0)
        pyglet.clock.set_fps_limit(30)
    def on_draw(self):
        self.state.on_draw()
    def update(self,*args):
        self.state.update(*args)
    def on_key_press(self,*args):
        if args[0]==key.O:
            self.state = Editor(self)
        if args[0]==key.P:
            self.state = Game(self)
        self.state.on_key_press(*args)
    def on_key_release(self,*args):
        self.state.on_key_release(*args)
    def on_mouse_press(self,*args):
        self.state.on_mouse_press(*args)
    def on_mouse_release(self,*args):
        self.state.on_mouse_release(*args)
    def on_mouse_drag(self,*args):
        self.state.on_mouse_drag(*args)

def main():
    main_win = GameWindow(width=640,height=480)

    pyglet.app.run()